<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="90px">
      <el-form-item label="公司名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入快递公司名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['his:express:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['his:express:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['his:express:remove']"
        >删除</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table  height="500" border v-loading="loading" :data="expressList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="快递公司编号" align="center" prop="code" />
      <el-table-column label="快递公司" align="center" prop="name" />
      <el-table-column label="OMS编号" align="center" prop="omsCode" />
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleAllot(scope.row)"
            v-hasPermi="['his:express:allot']"
          >分配公司</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['his:express:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['his:express:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改快递公司对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="快递公司简称" prop="code">
          <el-input v-model="form.code" placeholder="请输入快递公司简称" />
        </el-form-item>
        <el-form-item label="快递公司全称" prop="name">
          <el-input v-model="form.name" placeholder="请输入快递公司全称" />
        </el-form-item>
        <el-form-item label="OMS编号" prop="omsCode">
          <el-input v-model="form.omsCode" placeholder="请输入快递公司简称" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input-number :min="0"  v-model="form.sort" placeholder="请输入排序" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <el-dialog :title="allot.title" :visible.sync="allot.open" width="1100px"   append-to-body>
      <el-transfer
        filterable
        width="960px"
        :filter-method="filterMethod"
        filter-placeholder="请输入公司名称"
        v-model="value"
        :titles="['所有公司', '已选公司']"
        :right-default-checked="value"
        :data="allCompanies">
      </el-transfer>
      <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="handleAllotCompany">分 配</el-button>
          <el-button @click="cancel1">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listExpress, getExpress, delExpress, addExpress, updateExpress, exportExpress ,allotExpress ,getExpressList,getCompanyByOmsCode} from "@/api/hisStore/express";
import { getCompanyList} from "@/api/company/company";
export default {
  name: "Express",
  data() {
    return {

      formId:null,
        value: [],
        value2:[],
        filterMethod(query, item) {
          return item.label.indexOf(query) > -1;
        },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      allCompanies:undefined,
      allot:{
        title:"分配公司",
        open:false,
      },
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 快递公司表格数据
      expressList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        code: null,
        name: null,
        sort: null,
        isShow: null,
        isDel: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        code: [
          { required: true, message: "快递公司简称不能为空", trigger: "blur" }
        ],
        omsCode: [
          { required: true, message: "OMS编号不能为空", trigger: "blur" }
        ],
        name: [
          { required: true, message: "快递公司全称不能为空", trigger: "blur" }
        ],
        sort: [
          { required: true, message: "排序不能为空", trigger: "blur" }
        ],
        isShow: [
          { required: true, message: "是否显示不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();

  },

  methods: {
    handleAllotCompany(){
      console.log(this.value);
      allotExpress(this.value,this.formId).then(response => {
      if (response.code === 200) {
      this.msgSuccess("修改成功");
      this.allot.open = false;
      this.getList();
      }
      });
    },

    /** 查询快递公司列表 */
    getList() {
      this.loading = true;
      listExpress(this.queryParams).then(response => {
        this.expressList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    cancel1() {
      this.allot.open = false;
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        code: null,
        omsCode: null,
        name: null,
        sort: null,
        isShow: null,
        createTime: null,
        updateTime: null,
        isDel: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加快递公司";
    },
    /**分配公司按钮 */
    handleAllot(row){
      this.allot.open = true;
      this.formId = row.omsCode;
      getCompanyList().then(response => {
      let data = [];
      response.data.forEach((item,index) => {
        data.push({
          key: item.companyId,
          label:item.companyName,
        })
      });
      this.allCompanies = data;
    });
    const omsCode = row.omsCode;
    getCompanyByOmsCode(omsCode).then(response => {
      this.value = response.data2
      console.log(this.value);
    });

    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getExpress(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改快递公司";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateExpress(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addExpress(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除快递公司编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delExpress(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有快递公司数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportExpress(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  },
};
</script>
<style scoped lang="scss">
.container {
  display: flex;
  justify-content: space-between;
  margin-bottom: 20px;
}
.box {
  width: 300px;
}
.el-scrollbar {
  max-height: 300px;
  overflow-y: auto; /* 添加滚动条 */
}
/* 新增样式 */
.container {
  display: flex;
  justify-content: center;
  align-items: flex-start;
}
.box {
  margin: 0 10px;
}
.el-transfer-panel {
    width:40%;
}
.el-transfer-panel__body{
  height: 450px;
}
.el-transfer-panel__list.is-filterable {
   height: 88%;
}

</style>

